<template>
  <popup ref="popup" :overlay="true" :animation="true" @close="close">
    <div class="dish-panel">
      <div class="content">
        <div class="close-button">
          <close-button @click="() => $refs.popup && $refs.popup.close()" />
        </div>
        <div class="sections">
          <div
            class="photo"
            :style="{ 'background-image': `url(${data.image})` }"
          ></div>
          <div class="info">
            <h1 class="info-name">{{ data.name }}</h1>
            <div class="info-desc info-desc--large" v-if="data.description">
              {{ data.description }}
            </div>
          </div>
          <div
            class="section"
            v-for="(extra, extraKey) in data.extras"
            :key="extraKey"
          >
            <div class="section-name">{{ extra.name }}</div>
            <skm-options
              :multivalue="extra.isMultiple"
              :value="value.extra[extra.id] || []"
              @change="newValue => (value.extra[extra.id] = newValue)"
              :key="data.id + '.' + extra.id"
            >
              <div
                class="option border-bottom-0"
                v-for="(item, key) in extra.items"
                :key="key"
              >
                <skm-option :value="item.id">
                  <div class="extra">
                    <div class="extra-name">{{ item.name }}</div>
                    <div class="extra-price" v-if="item.value">
                      +<price :price="item.value" />
                    </div>
                  </div>
                </skm-option>
              </div>
            </skm-options>
          </div>
          <div class="note">
            <div class="note-title">{{ $t("preorderProductPanel.note") }}</div>
            <textarea
              class="note-input"
              :placeholder="$t('preorderProductPanel.notePlaceholder')"
              @change="e => (value.note = e.target.value)"
              v-model="value.note"
            />
          </div>
        </div>
        <div class="controller">
          <div class="counter">
            <button
              class="counter-minus"
              :disabled="value.count === 1 || !data.status"
              @click="value.count -= 1"
            ></button>
            <span class="counter-number">{{ value.count }}</span>
            <button
              class="counter-plus"
              @click="value.count += 1"
              :disabled="reachMaxCount || !data.status"
            ></button>
          </div>
          <button
            class="submit"
            :disabled="disabled || !data.status || overMaxCount"
            @click="done"
          >
            <span class="submit-label">{{
              orderValue
                ? $t("preorderProductPanel.updateCart")
                : $t("preorderProductPanel.addToCart")
            }}</span>
            <span class="submit-price"><price :price="totalPrice"/></span>
          </button>
          <div v-if="reachMaxCount" class="limited-qty-message">
            {{ $t(`${dishPanelScope}.limitedQty`) }}
            <span v-if="countInCart > 0 && isPreorder">{{
              $t("preorderProductPanel.cartInCount", { count: countInCart })
            }}</span>
          </div>
          <div v-if="disabled" class="unavailable-message">
            {{ $t("preorderProductPanel.unavailableMessage") }}
          </div>
          <div v-if="!data.status" class="unavailable-message">
            {{ $t("preorderProductPanel.unavailableMessage2") }}
          </div>
        </div>
      </div>
    </div>
  </popup>
</template>

<script>
import uuid from "uuid/v4";
import Popup from "../../Popup";
import Price from "@/components/Price";
import { mapActions, mapState } from "vuex";
import CloseButton from "@/components/CloseButton";
import { Options, Option } from "@/components/Options";

export default {
  components: {
    Popup,
    Price,
    CloseButton,
    SkmOptions: Options,
    SkmOption: Option
  },

  props: {
    data: {
      type: Object
    },
    cart: {
      type: Array
    },
    orderValue: {
      type: Object,
      default: null
    },

    disabled: {
      type: Boolean,
      default: false
    }
  },

  data() {
    return {
      value: this.orderValue
        ? JSON.parse(JSON.stringify(this.orderValue))
        : {
            id: uuid(),
            dish: this.data,
            extra: {},
            note: "",
            count: 1,
            price: this.data.price
          }
    };
  },

  computed: {
    ...mapState("restaurant", ["restaurant"]),
    countInCart() {
      let count = 0;
      if (this.isPreorder) {
        count = this.cart
          .filter(item => item.dish.id === this.data.id)
          .map(item => item.count)
          .reduce((sum, count) => sum + count, 0);
        if (this.orderValue) {
          count -= this.orderValue.count;
        }
      } else if (this.isDelivery) {
        count = this.cart
          .map(item => item.count)
          .reduce((sum, count) => sum + count, 0);
        if (this.orderValue) {
          count -= this.orderValue.count;
        }
      }

      return count;
    },
    reachMaxCount() {
      return this.value.count + this.countInCart >= 8;
    },
    overMaxCount() {
      return this.value.count + this.countInCart > 8;
    },
    totalPrice() {
      var price = this.data.price;
      const extraMap = this.data.extras.reduce((map, extra) => {
        map[extra.id] = extra.items.reduce((itemMap, item) => {
          itemMap[item.id] = item;
          return itemMap;
        }, {});
        return map;
      }, {});
      for (let [extraId, itemIds] of Object.entries(this.value.extra)) {
        const extra = extraMap[extraId];
        price += itemIds.reduce(
          (total, itemId) => total + extra[itemId].value,
          0
        );
      }
      return price * this.value.count;
    },
    isPreorder() {
      return this.$route.name === "RestaurantPreorder";
    },

    isDelivery() {
      return this.$route.name === "RestaurantDelivery";
    },

    dishPanelScope() {
      return this.isPreorder
        ? "preorderProductPanel"
        : this.isDelivery
        ? "deliveryProductPanel"
        : "";
    }
  },

  methods: {
    ...mapActions(["show"]),

    close() {
      this.$emit("close");
    },

    done() {
      this.value.price = this.totalPrice;
      this.$emit("done", this.value, !this.orderValue);
      this.trackAdd();
    },

    trackOpen() {
      window.gtag("event", "Meal - Enter", {
        event_label: JSON.stringify({
          ...this.restaurant.dataForMixpanel,
          meal: {
            name: this.data.name
          }
        })
      });
    },

    trackAdd() {
      window.gtag("event", "Add to cart", {
        event_label: JSON.stringify({
          ...this.restaurant.dataForMixpanel,
          meal: {
            name: this.data.name
          }
        })
      });
    }
  },

  mounted() {
    this.trackOpen();
    this.value.extra = this.data.extras.reduce((value, extra) => {
      if (this.value.extra[extra.id]) {
        value[extra.id] = this.value.extra[extra.id];
      } else {
        const itemIds = extra.items
          .filter(item => item.isDefault)
          .map(item => item.id);
        value[extra.id] = itemIds;
      }
      return value;
    }, {});
    setTimeout(() => {
      this.show();
    }, 200);
  }
};
</script>

<style lang="scss" scoped>
.dish-panel {
  position: relative;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  margin: 0 auto;
  user-select: none;
  text-align: center;
  box-sizing: border-box;

  @include media-breakpoint-up(md) {
    &::after {
      content: "";
      display: inline-block;
      height: 100%;
      width: 0;
      vertical-align: middle;
    }
  }
}

.content {
  display: flex;
  flex-direction: column;
  position: absolute;
  left: 0;
  top: 0;
  right: 0;
  bottom: 0;
  background: $color-white;
  overflow: hidden;
  box-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);
  text-align: left;

  @include media-breakpoint-up(md) {
    display: inline-flex;
    width: 540px;
    max-height: 90vh;
    position: relative;
    vertical-align: middle;
  }
}

.photo {
  height: 0;
  padding-bottom: 42.6%;
  background-position: center center;
  background-size: cover;

  @include media-breakpoint-up(md) {
    padding-bottom: 56.2962963%;
  }
}

.info {
  padding: 12px 20px;

  @include media-breakpoint-up(md) {
    padding-left: 30px;
    padding-right: 30px;
  }
}

.info-name {
  font-size: 18px;
  font-weight: 500;
  margin: 0;
  line-height: 1.78em;
  margin-bottom: 2px;

  @include media-breakpoint-up(md) {
    font-size: 28px;
  }
}

.info-desc {
  font-size: 12px;
  color: $color-primary-grey;
  line-height: 1.67em;

  &--large {
    font-size: 16px;
  }
}

.section-name {
  color: $color-primary-grey;
  background: $color-genesis-white;
  font-size: 12px;
  padding: 0 20px;
  line-height: 28px;

  @include media-breakpoint-up(md) {
    background: transparent;
    font-size: 18px;
    color: inherit;
    font-weight: 500;
    padding-left: 30px;
    padding-right: 30px;
  }
}

.sections {
  overflow-y: scroll;
}

.controller {
  position: relative;
  flex-shrink: 0;
  flex-grow: 0;
  padding: 10px 15px 15px;
  flex-wrap: wrap;

  &::after {
    content: "";
    position: absolute;
    left: 0;
    top: -60px;
    width: 100%;
    height: 60px;
    background-image: linear-gradient(
      to bottom,
      rgba(255, 255, 255, 0),
      $color-white
    );
    pointer-events: none;
  }

  @include media-breakpoint-up(md) {
    display: flex;
    align-items: center;
    padding: 15px 30px 15px;
    box-shadow: 0 -2px 4px 0 rgba(0, 0, 0, 0.1);

    &::after {
      display: none;
    }
  }
}

.counter {
  display: flex;
  border: 1px $color-sky-grey solid;
  border-radius: 6px;
  box-sizing: border-box;
  height: 44px;
  line-height: 44px;
  text-align: center;

  @include media-breakpoint-up(md) {
    flex: 1;
    display: inline-flex;
    height: 48px;
    line-height: 48px;
    margin-right: 20px;
  }
}

.counter-number {
  width: 48%;
}

.counter-plus,
.counter-minus {
  position: relative;
  width: 26%;
  padding: 0;
  margin: 0;
  border: none;
  background: transparent;
  cursor: pointer;
}

.counter-plus {
  border-left: 1px $color-sky-grey solid;

  &::after,
  &::before {
    content: "";
    position: absolute;
    top: 50%;
    left: 50%;
    height: 2px;
    width: 12px;
    margin-left: -6px;
    margin-top: -1px;
    background: $color-primary-black;
  }

  &::after {
    transform: rotateZ(90deg);
  }

  &:disabled::before,
  &:disabled::after {
    background: $color-silver-grey;
  }
}

.counter-minus {
  border-right: 1px $color-sky-grey solid;

  &::before {
    content: "";
    position: absolute;
    top: 50%;
    left: 50%;
    height: 2px;
    width: 12px;
    margin-left: -6px;
    margin-top: -1px;
    background: $color-primary-black;
  }

  &:disabled::before {
    background: $color-silver-grey;
  }
}

.submit {
  display: flex;
  width: 100%;
  border: none;
  background: $color-skm-red;
  color: $color-white;
  padding: 0 10px 0 20px;
  margin: 10px 0 0;
  cursor: pointer;
  line-height: 48px;
  border-radius: 2px;

  &:disabled {
    background: $color-silver-grey;
  }

  @include media-breakpoint-up(md) {
    flex: 1;
    display: inline-flex;
    margin: 0;
    padding: 0 20px 0 20px;
  }
}

.submit-label {
  flex: 1;
  text-align: left;
}

.submit-price {
  flex: 1;
  text-align: right;
  white-space: nowrap;
  overflow: hidden;
}

.option {
  padding: 0 20px;
  line-height: 48px;
  border-bottom: 1px $color-sky-grey solid;
  box-sizing: border-box;

  @include media-breakpoint-up(md) {
    padding: 0;
    margin: 0 30px;
  }
}

.extra {
  display: flex;
  width: 100%;
}

.extra-name {
  flex: 1 1 80%;
  white-space: nowrap;

  @include media-breakpoint-up(md) {
    font-size: 18px;
  }
}

.extra-price {
  flex: 1 1 20%;
  text-align: right;
  white-space: nowrap;
  font-size: 14px;

  @include media-breakpoint-up(md) {
    font-size: inherit;
  }
}

.note {
  padding: 20px 20px 60px;

  @include media-breakpoint-up(md) {
    padding-bottom: 20px;
    padding-left: 30px;
    padding-right: 30px;
  }
}

.note-title {
  font-size: 14px;
  margin-bottom: 10px;
  color: $color-primary-black;

  @include media-breakpoint-up(md) {
    font-size: 16px;
  }
}

.note-input {
  border: 1px $color-pigeon-grey solid;
  width: 100%;
  border-radius: 2px;
  padding: 10px 15px;
  box-sizing: border-box;
  resize: none;
  color: $color-primary-black;

  &::placeholder {
    color: $color-silver-grey;
  }
}

.close-button {
  position: absolute;
  z-index: 1;
  top: 10px;
  right: 10px;
  width: 32px;
  height: 32px;

  @include media-breakpoint-up(md) {
    top: 20px;
    right: 20px;
  }
}

.unavailable-message {
  width: 100%;
  font-size: 12px;
  text-align: center;
  color: $color-skm-red;
  margin-top: 10px;
}

.limited-qty-message {
  width: 100%;
  font-size: 14px;
  color: $color-skm-red;
  margin-top: 10px;
}
</style>
